;===========================================================================================
; Menu_2.asm  GoAsm assembler
; Base d'application avec menus et touches acclres
; Programm par AsmGges France
;===========================================================================================
; compile.bat:
; ..\..\bin\GoRC /r, res\menu_2.rc
; ..\..\bin\GoAsm menu_2.asm
; ..\..\bin\GoLink menu_2.obj res\menu_2.res user32.dll kernel32.dll
;===========================================================================================

; Inclusion des macros/quates/structures ncessaires au programme
; ----------------------------------------------------------------
  #include "..\..\inc\Windows.inc"
  #include "..\..\inc\all_api.inc"

  ID_FRANCE      = 17

  IDM_MENU       = 37

  IDM_NOUVEAU    = 101          ;sub menu 1_1
  IDM_OUVRIR     = 102          ;sub menu 1_2
  IDM_SAUVER     = 103          ;sub menu 1_3
  IDM_SAUVERSOUS = 104          ;sub menu 1_4
  IDM_QUITTER    = 105          ;sub menu 1_5

  IDM_ANNULER    = 201          ;sub menu 2_1
  IDM_COUPER     = 202          ;sub menu 2_2
  IDM_COPIER     = 203          ;sub menu 2_3
  IDM_COLLER     = 204          ;sub menu 2_4
  IDM_SELECTIONT = 206          ;sub menu 2_5

  IDM_LISEZMOI   = 301          ;sub menu 3_1
  IDM_APROPOS    = 302          ;sub menu 3_2

  IDK_ACCEL      = 401

;===========================================================================================
; Dbut du code programme
; -----------------------
.code

start:
    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc.hInstance],eax

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadIcon,[wc.hInstance],ID_FRANCE
    mov [wc.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc.hCursor],eax

    ; Chargement d'un menu
    ; --------------------
    invoke LoadMenu,[wc.hInstance],IDM_MENU
    mov [hMenu],eax

    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,addr wc

    ; Charge la table des acclrateurs
    ; ---------------------------------
    invoke LoadAcceleratorsA,[wc.hInstance],IDK_ACCEL
    mov [hAccel],eax

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr ClassName,addr Title,\
                          WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
                          [WinX],[WinY],[WinW],[WinH],0,[hMenu],[wc.hInstance],0
    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,addr msg,0,0,0
    or eax,eax
    jz >ExitProgram

    ; Traduit les touches acclres en messages
    ; ------------------------------------------
    invoke TranslateAccelerator,[hWnd],[hAccel],addr msg
    or  eax,eax
    jnz <MessageLoop

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,addr msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,addr msg

    jmp <MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
WindowProc frame @hWnd, @uMsg, @wParam, @lParam
    uses ebx,esi,edi 

    cmp D[@uMsg],WM_CLOSE
    jne >.wmcommand
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],addr MsgEnd,addr ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; -------------------------------
        invoke PostQuitMessage,0
        jmp >>.exit

    .wmcommand:
    cmp D[@uMsg],WM_COMMAND
    jne >>.defwindowproc
        mov  eax,[@wParam]
        cmp eax,IDM_NOUVEAU         ;sub menu 1_1
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_OUVRIR          ;sub menu 1_2
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_SAUVER          ;sub menu 1_3
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_SAUVERSOUS      ;sub menu 1_4
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_QUITTER         ;sub menu 1_5
        jne >
            ; Boite  message sous menu 1_5
            ; -----------------------------
            invoke MessageBox,[@hWnd],addr MsgBoxSM1_3,addr ClassName,\
                                             MB_OK+MB_ICONINFORMATION

            ; Demande la fin de l'application
            ; -------------------------------
            invoke PostQuitMessage,0
            jmp >.exit

        cmp eax,IDM_ANNULER         ;sub menu 2_1
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_COUPER          ;sub menu 2_2
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_COPIER          ;sub menu 2_3
        jne >
            ; code
        cmp eax,IDM_COLLER          ;sub menu 2_4
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_SELECTIONT      ;sub menu 2_5
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_LISEZMOI        ;sub menu 3_1
        jne >
            ; code
            jmp >.messagebox
        :
        cmp eax,IDM_APROPOS         ;sub menu 3_2
        jne >.messagebox
            ; code

        .messagebox:
        ; Boite  message
        ; ---------------
        invoke MessageBox,[@hWnd],addr MsgBox,addr ClassName,MB_OK+MB_ICONINFORMATION
        jmp >.exit

    .defwindowproc:
        ; Traitement par dfaut des autres messages Windows
        ; -------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        ret

    .exit:
    mov eax,0
    ret
endf

;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
;-------------------------------------------------------------------------------------------
.data

  Title       db " Base d'application",0
  ClassName   db ' AsmGges Win32',0
  MsgEnd      db ' GoAsm AsmGges France @2006  ',0
  MsgBox      db "Base d'application",13,10
              db 'GoAsm AsmGges France @2006',0
  MsgBoxSM1_3 db 'Fin de programme !',0
  align 4

  WinX        dd 0
  WinY        dd 0
  WinW        dd 512
  WinH        dd 352

  hWnd        dd ?
  hMenu       dd ?
  hAccel      dd ?
  wc          WNDCLASS < 0,addr WindowProc,0,0,NULL,NULL,NULL,\
                         COLOR_WINDOW+1,NULL,addr ClassName >
  msg         MSG      <>

;===========================================================================================
